"use strict";

const Promise = require("bluebird");
const memoizee = require("memoizee");

const lvm = require("../../../packages/exec-lvm");
const All = require("../../../packages/graphql-interface/symbols/all");

module.exports = function () {
	let getLogicalVolumesOnce = memoizee(lvm.getLogicalVolumes);

	return function (paths) {
		return Promise.try(() => {
			return getLogicalVolumesOnce();
		}).then((result) => {
			return result.volumes;
		}).then((volumes) => {
			return paths.map((path) => {
				if (path === All) {
					return volumes;
				} else {
					return volumes.find((device) => device.path === path);
				}
			});
		});
	};
};
