"use strict";

const Promise = require("bluebird");
const smartctl = require("../../../packages/exec-smartctl");
const dlayerWrap = require("../../../packages/dlayer-wrap");

module.exports = function () {
	return function (paths) {
		return Promise.map(paths, (path) => {
			return dlayerWrap(() => smartctl.attributes({ devicePath: path }), {
				allowedErrors: [ smartctl.AttributesError ]
			});
		});
	};
};
