"use strict";

const Promise = require("bluebird");
const dlayerWrap = require("../../../packages/dlayer-wrap");
const smartctl = require("../../../packages/exec-smartctl");

module.exports = function () {
	return function (paths) {
		return Promise.map(paths, (path) => {
			return dlayerWrap(() => smartctl.info({ devicePath: path }), {
				allowedErrors: [ smartctl.InfoError ]
			});
		});
	};
};
